import { SGraphCommand } from "@saga-web/graph/lib/commands/SGraphCommand";
import { SGraphItem } from "@saga-web/graph/lib/SGraphItem";
import { SGraphScene } from "@saga-web/graph/lib/SGraphScene";
import { SUndoCommand } from "@saga-web/base/lib";
/**
 * 添加多个item命令
 *
 * @author  han_yao_long
 * */

export class SGraphAddListCommand extends SGraphCommand {
    /** 命令item对象    */
    itemList: SGraphItem[];
    /** 命令item的父类   */
    parent: SGraphItem | null;
    constructor(scene: SGraphScene, itemList: SGraphItem[]) {
        super(scene);
        this.itemList = itemList;
        this.parent = itemList[0].parent;
    }
    /**
   * 合并命令
   *
   * @return  boolean 是否已执行合并
   * */
    mergeWith(command: SUndoCommand): boolean {
        return false;
    } // Function mergeWith()

    /**
     * 重做
     *
     * */
    redo(): void {
        this.itemList.map((item) => {
            item.parent = this.parent;
        })
        // @ts-ignore
        this.parent.update();
    } // Function redo()

    /**
     * 撤销
     *
     * */
    undo(): void {
        this.itemList.map((item) => {
            item.parent = null;
        })
        // @ts-ignore
        this.parent.update();
    } // Function undo()
}